;;;
;;; lspool.el
;;; 94.11.01 Created by T.Ishikura (BAA) <ishikura@pisces.bekkoame.or.jp>
;;;

;;
;; You can redistribute it and/or modify it under the terms of the
;; GNU General Public License as published by the Free Software 
;; Foundation; either version 2, or (at your option) any later version.
;;

;; $B$d$i$J$-$cBLL\$J$3$H!#(B
;;
;; $B%]%9%H$9$k%"!<%F%#%/%k$N87$7$$%A%'%C%/!#(B
;;
;; $BJ#?t$N%"!<%F%#%/%k$r%j%9%H$KEPO?$7$h$&$H$9$k>l9g$O!"Bg$-$$J}$K$9$k!#(B
;;
;; $B%(%i!<$,5/$-$?;~$O!"%P%C%U%!$r2r@OCf$N%m%0$K@Z$jBX$($F!"(B
;; $B$I$&$9$k$+J9$/MM$K$9$k!#(B
;;
;; $BF1Js%a!<%k$N%5%]!<%H(B
;;
;; $B9bB.2=(B
;;
;; $B%"%C%W%m!<%I%U%!%$%k$r$^$H$b$K$9$k(B
;;
;; $B%]%9%H$7$?%"!<%F%#%/%k!"%a!<%k$r%"!<%F%#%/%k%j%9%H$KDI2C$9$k(B
;; $B%-%c%s%;%k$b2DG=$K$9$k(B
;;
;; NewsGroup $BL>$r%-!<%o!<%I$K!"%\!<%I$N%?%$%H%k$d(B ID ($BHV9f(B)$B!"%\!<%I%M!<%`!"(B
;; $B%\!<%I$N<oN`Ey$N>pJs$r4^$s$@%j%9%H$r:n$j!"$=$l$H!"(Blspool-hosts-alist
;; $B$r(B ~/.lspool.el $B$KDI$$=P$9!#(B(pp $B$r$D$+$&(B)
;;
;; $B%a%$%W%k$N%^%k%A%]%9%H$N%5%]!<%H(B
;;
;; netcock $B$N%P%C%A%;%C%H$N%5%]!<%H(B
;;
;; muhost $B$N%\!<%I%$%s%U%)$N%5%]!<%H(B
;;
;; netcock $B$G!"$&$^$/(B message-id $B$r$G$C$A$"$2$k!#(B
;;
;; article-list $B$NJ}$K!"HV9f$r;}$?$J$$5-;v$r07$($k$h$&$J9=B$$r:n$j!"(B
;; $B%5%s%G!<$N%\!<%I%$%s%U%)Ey$r!"$=$3$K$$$l$k!#$3$l$b!"(Bmessage-id $B$r(B
;; $B$I$&$G$C$A$"$2$k$+$,Fq$7$$!#(B
;;
;; $B>e$N;v$r<B8=$7$?$"$H!"(Bmmm, $B3(M}9a$N%"!<%F%#%/%k$N9=B$$r!"HV9f$r;}(B
;; $B$C$?%Y!<%9$N%"!<%F%#%/%k$H!"$=$l$X$N(B reference $B$r;}$C$?HV9fL5$7$N(B
;; $B%"!<%F%#%/%k$H$7$F<B8=$9$k!#(B 
;;
;; $B%a%$%W%k$GJ#?t$N5-;v$N(B reference $B$N%5%]!<%H!#(B($B$G$-$?!"$,!"0UL#$,L5$+$C$?(B)
;;
;; .newsrc $B$r%;!<%V$9$kA0$K!"(Bnetwork-sx.mail $B$N$h$&$J!"HV9f$r;}$?$J$$(B
;; $B%"!<%F%#%/%k$h$&$N%\!<%I$NHV9f$r>C5n$9$k!#(B($B$G$-$?(B)
;;
;; $B$"$k9T$,@55,I=8=$K%^%C%A$7$F$$$k$+D4$Y$k$h$&$JJ*$,B?$$$N$G!"$=$&$$$C$?(B
;; $B4X?t$r:n$C$F!"%W%m%0%i%`$r8+$d$9$/$9$k!#(B(n $B9T0JFb$K$"$k%Q%?!<%s$,%^%C%A$9$k$+!#(B)
;;
;; Date $B$r0l1~!"(Binternet news $B$N7A<0$K$"$o$;$k$h$&$K$9$k!#(B($B$3$l$b0UL#L5$7$C$]$$$1$I!#(B)
;;
;; $B%m%0%U%!%$%k!"%"%C%W%m!<%I%U%!%$%k$NJ8;z%3!<%I$r;XDj$G$-$k$h$&$K$9$k!#(B
;;

;; ---- kent
;; lspool-(post|mail)-kt: subject$B$NJ8;z?t$O$$$/$D$@!)(B
;;
;; nifty $B$G!"(BInternet $B$+$iMh$?(B mail $B$KJV;v$,=P$;$J$$!#(B
;; lspool-sendmail-send-it $BFb$,LdBj(B
;;
;; nifty $B$b(B kt $B$b!"%a%$%k$GJ#?t$N08@h$r;XDj$9$k$H$*$+$7$/$J$k$H;W$&(B
;;

(require 'nntp)
(require 'sendmail)
(require 'gnus)

(defconst lspool-version "0.19")

(defvar lspool-analysis-buffer nil
  "$B%m%0%U%!%$%k2r@OMQ%P%C%U%!!"DL>o$O(B \" *LOG ANALYSIS*\"$B!#(B")

(defvar lspool-hosts-alist
  '(("network-sx" lspool-analyze-logfile-netcock lspool-post-netcock
     lspool-mail-netcock "sx.up"
     (5000 "		    SX-WINDOW & X680x0
		Developer's and User's party" nil))
    ("nwsx-ng" lspool-analyze-logfile-netcock lspool-post-netcock
     lspool-mail-netcock "sxng.up"
     (5000 "                        Network-SX 68k NG

            X680x0, SX-WINDOW User's & Developer's Party" nil))
    ("mippei" lspool-analyze-logfile-netcock lspool-post-netcock
     lspool-mail-netcock nil
     (5000 "*** $BL)JD%M%C%H$K@\B3$5$l$^$7$?(B ***" nil))
    ("maria" lspool-analyze-logfile-netcock lspool-post-netcock
     lspool-mail-netcock nil
     (5000 "---> Saint Marianne " nil))
    ("panic" lspool-analyze-logfile-netcock lspool-post-netcock
     lspool-mail-netcock nil
     (5000 "<<<<< Welcome to panic BBS - Computer Animation Factory >>>>>" nil))
    ("alta" lspool-analyze-logfile-netcock lspool-post-netcock
     lspool-mail-netcock nil
     (5000 "Alta-Net\nTEL 03-5474-1871" nil))
    ("netcock" lspool-analyze-logfile-netcock lspool-post-netcock
     lspool-mail-netcock nil nil)
    ("internet" lspool-analyze-logfile-rmail-netnews lspool-post-rmail-netnews
     nil nil
     (5000 "*** EOOH ***\nPath: " nil))
    ("sunday" lspool-analyze-logfile-muhost lspool-post-muhost
     lspool-mail-muhost nil
     (5000 "(Guest ID = sun0000)" nil))
    ("bigmodel" lspool-analyze-logfile-bigmodel lspool-post-bigmodel
     lspool-mail-bigmodel nil nil)
    ("natsume" lspool-analyze-logfile-bigmodel lspool-post-bigmodel
     lspool-mail-bigmodel nil
     (5000 "=====================================\n Natsume Net" nil))
    ("kt" lspool-analyze-logfile-kt lspool-post-kt
     lspool-mail-kt nil nil)
    ("yui" lspool-analyze-logfile-kt lspool-post-kt
     lspool-mail-kt "yui.up"
     (5000 "$B"!!!(B $B!T3yAR!U!!$f$$#N#E#T!!(B $B"!(B" nil))
    ("nifty" lspool-analyze-logfile-nifty lspool-post-nifty
     lspool-mail-nifty "nif.up"
     (5000 "$B$h$&$3$=(BNIFTY-Serve$B$X(B" nil))
    ("rt" lspool-analyze-logfile-rt lspool-post-rt
     lspool-mail-rt nil nil)
    ("erika" lspool-analyze-logfile-erika lspool-post-erika
     lspool-mail-erika nil nil)
    ("mmm" lspool-analyze-logfile-mmm lspool-post-mmm
     lspool-mail-mmm nil nil)
    ("exe-net" lspool-analyze-logfile-mmm lspool-post-mmm
     lspool-mail-mmm nil
     (5000 "exexexe$B"#(Bxexexexexexexe$B"#(Bxe$B"#(Bxexexe$B"#(Bxexexexexex$B"#(Bexex$B"#(B  $B"#"#!z(B    $B"#(B   " nil))
    ("maple" lspool-analyze-logfile-maple lspool-post-maple
     lspool-mail-maple nil
     (5000 "\\*\\*    Welcome to Mapletown Network    \\*\\*\\|^### mail allread\n\\|^### profile allread\n\\|^### bbs allread\n" t))
    ("host-pro" lspool-analyze-logfile-hostpro lspool-post-hostpro
     lspool-mail-hostpro nil nil))
  "$B%[%9%HL>$+$i%[%9%H0MB84X?t$rF@$k%j%9%H!#(B

(($B%[%9%HL>(B $B%m%0%U%!%$%k2r@OMQ4X?t(B $B%"!<%F%#%/%k%]%9%HMQ4X?t(B $B%a!<%kMQ4X?t(B
  $B%"%C%W%m!<%I%U%!%$%kL>(B $B%[%9%HL>7hDjMQ%j%9%H(B)
  .....)

$B%[%9%HL>7hDjMQ%j%9%H$O!"(B
($B8!:w$9$kD9$5(B $B8!:wJ8;zNs(B $B@55,I=8=$+C1$J$kJ8;zNs$+$N%U%i%0(B)"
)

(defvar lspool-logfile nil)

(defvar lspool-host-name nil
"$B8=:_2r@OCf%U%!%$%k$N$N%[%9%HL>(B")

(defvar lspool-select-host-name-function
  'lspool-select-host-name-from-logfile-contents)

(defvar lspool-insert-news-headers nil
"* nil $B$G$J$$$J$i$P!"%"!<%F%#%/%k$NK\J8$NA0$K(B internet news $B7A<0$N(B
$B%X%C%@$rA^F~$9$k!#(B")

(defvar lspool-display-board-title t
"* nil $B$G$J$$$J$i$P!"(Bnewsgroup $B%b!<%I$G!"%\!<%I%$%s%U%)$rI=<($9$k!#(B")

(defvar lspool-nntp-answer-coding-system nil
"lspool $B$,(B lspool-request-article $B$GJV$9CM$N(B coding system $B$r;XDj$9$k!#(B")

(defvar internet-top-newsgoups
  '("alt" "comp" "fj" "rec" "soc" "tnn" "k12" "jp" "aus" "fido" "dc" "lobby"
    "gnu" "bionet" "chinese" "info" "misc" "news" "sci" "demon" "gcl" "maus"
    "talk" "us" "vmsnet" "bit" "ieee" "pin" "fi" "de" "biz" "cmu" "linux"
    "mech" "os" "pingnet" "su" "ucb" "ucam" "uk" "tw"
     "u-tokyo" "tsukuba" "tecc" "iij" "bekkoame" "rim" "okinawa" "kanto")
  "(\"alt\" \"comp\" ....) $B$N7A$N(B list$B!#$3$N(B alist $B$K4^$^$l$kJ8;zNs$+$i(B
$B;O$^$k%K%e!<%:%0%k!<%W$X$N%]%9%H$O!"(Binternet $B$X$N%]%9%H$H$_$J$9!#(B")

(defvar lspool-delete-newsgroup-regexp
  "^internet\\.\\|^bigmodel\\.\\|^netcock\\.\\|^mmm\\.\\|^rt\\.\\|^kt\\.\\|\\.mail\\'"
  "gnus $B=*N;;~$K(B .newsrc $B$+$i:o=|$9$k(B newsgroup $BL>(B
$B$r;XDj$9$k@55,I=8=!#(B")

(defvar lspool-board-title-position 30
  "**Newsgroup* $B%P%C%U%!$G%\!<%I%?%$%H%k$rI=<($9$k0LCV!#(B")

(defvar lspool-ignored-headers
"^Path:\\|^Posting-Version:\\|^Article-I.D.:\\|^Expires:\\|^Date-Received:\\|^References:\\|^Control:\\|^Xref:\\|^Lines:\\|^Posted:\\|^Relay-Version:\\|^Message-ID:\\|^Nf-ID:\\|^Nf-From:\\|^Approved:\\|^Sender:\\|^Message-ID:\\|^From:\\|^Subject:\\|^Date:\\|^Newsgroups:\\|^Followup-To:\\|^Distribution:\\|^In-Reply-To:\\|^NNTP-Posting-Host:\\|^X-Newsreader:"

  "gnus-lspool $B$GI=<($7$J$$%X%C%@$r;XDj$9$k@55,I=8=!#(B
nil $B$G$J$$$J$i!"(Bgnus-lspool $B$N%9%?!<%H;~$K!"$3$NCM$r(B
 gnus-ignored-headers $B$K%;%C%H$9$k!#(B")

(defvar lspool-use-article-list-id t
  "nil $B$G$J$$$H$-!"%"!<%F%#%/%k(B ID $B$K$h$k%"%/%;%9$r2DG=$K$9$k!#(B")

;;
;;
;;

(defvar lspool-article-hashtb nil
  "$B2r@O$7$?%m%0$NCf$N%"!<%F%#%/%k$N>pJs$r4^$s$@Fs=E$N%O%C%7%e%F!<%V%k!#(B

NEWSGRUOP $BL>$r%-!<$H$7$F;}$A!"$=$N(B NEWSGROUP $B$N%"!<%F%#%/%k$N>pJs(B
$B$r4^$s$@%O%C%7%e%F!<%V%k$rCM$H$7$F;}$D!#(B

NEWSGROUP $B$N%"!<%F%#%/%k$N>pJs$r4^$s$@%O%C%7%e%F!<%V%k$O!"J8;zNs(B
ARTICLE-NO $B$r%-!<$H$7$F;}$A!"(B(HEADER_VECTOR ARTICLE_START
ARTICLE-END) $B$rCM$K;}$D!#(B

ARTICLE_START ARTICLE_END $B$O(B LSPOOL-ANALYSIS-BUFFER $BCf$N(B
$B%"!<%F%#%/%k$X$N%]%$%s%?(B($B@0?t(B)$B!#(B
HEADER_VECTOR $B$O(B NNTP-RETRIEVE-HEADERS $B$NJV$9%Y%/%H%k$HF1$8J*!#(B" )

(defvar lspool-article-hashtb-by-id nil
  "MESSAGE-ID $B$r%-!<$H$7$F!"(B(HEADER_VECTOR ARTICLE_START
ARTICLE-END) $B$rCM$K;}$D(B hashtable$B!#(B

ARTICLE_START ARTICLE_END $B$O(B LSPOOL-ANALYSIS-BUFFER $BCf$N(B
$B%"!<%F%#%/%k$X$N%]%$%s%?(B($B@0?t(B)$B!#(B
HEADER_VECTOR $B$O(B NNTP-RETRIEVE-HEADERS $B$NJV$9%Y%/%H%k$HF1$8J*!#(B" )

(defvar lspool-board-title-list nil
  "newsgroup $BL>$H(B $B%\!<%I%?%$%H%k$rBP1~$5$;$k(B alist
((NEWSGROUP BOARD_TITLE) ......)")

(defvar lspool-current-board nil
  "lspool-request-group $B$GA*Br$5$l$?%K%e!<%:%0%k!<%W(B")

(defvar lspool-current-board-article-hashtb nil)

(defvar lspool-analyze-board-list nil
  "$B%"!<%F%#%/%k$N%X%C%@$K%\!<%IL>$r4^$^$J$$%m%0$r2r@O$9$k;~!"(B
$B%\!<%IL>$r<($9J8;zNs$r8+IU$1$?%]%$%s%H$H%\!<%IL>$r(B
((POINT BOARD_NAME) ...) $B$N7A$G5-O?$9$k(B")

(defvar lspool-analyze-current-board nil
  "$B%"!<%F%#%/%k$N%X%C%@$K%\!<%IL>$r4^$^$J$$%m%0$r2r@O$9$k;~!"(B
$B8=:_2r@OCf$N%\!<%IL>$,F~$C$F$$$k(B")


;;
;; patch for gnus
;;

(setq gnus-access-methods
  '((nntp
     (gnus-retrieve-headers		nntp-retrieve-headers)
     (gnus-open-server			nntp-open-server)
     (gnus-close-server			nntp-close-server)
     (gnus-server-opened		nntp-server-opened)
     (gnus-status-message		nntp-status-message)
     (gnus-request-article		nntp-request-article)
     (gnus-request-group		nntp-request-group)
     (gnus-request-list			nntp-request-list)
     (gnus-request-list-newsgroups	nntp-request-list-newsgroups)
     (gnus-request-list-distributions	nntp-request-list-distributions)
     (gnus-request-post			nntp-request-post))
    (nnspool
     (gnus-retrieve-headers		nnspool-retrieve-headers)
     (gnus-open-server			nnspool-open-server)
     (gnus-close-server			nnspool-close-server)
     (gnus-server-opened		nnspool-server-opened)
     (gnus-status-message		nnspool-status-message)
     (gnus-request-article		nnspool-request-article)
     (gnus-request-group		nnspool-request-group)
     (gnus-request-list			nnspool-request-list)
     (gnus-request-list-newsgroups	nnspool-request-list-newsgroups)
     (gnus-request-list-distributions	nnspool-request-list-distributions)
     (gnus-request-post			nnspool-request-post))
    (mhspool
     (gnus-retrieve-headers		lspool-retrieve-headers)
     (gnus-open-server			lspool-open-server)
     (gnus-close-server			lspool-close-server)
     (gnus-server-opened		lspool-server-opened)
     (gnus-status-message		lspool-status-message)
     (gnus-request-article		lspool-request-article)
     (gnus-request-group		lspool-request-group)
     (gnus-request-list			lspool-request-list)
     (gnus-request-list-newsgroups	lspool-request-list-newsgroups)
     (gnus-request-list-distributions	lspool-request-list-distributions)
     (gnus-request-post			lspool-request-post)

     ;;
     ;; it is not input method.
     ;;

     (gnus-group-get-new-news lspool-group-get-new-news)

;; for gnus 3.14
;;
     (gnus-Group-get-new-news lspool-group-get-new-news)
;;
;;

)))

;; for gnus 3.14
;;
(if (fboundp 'gnus-group-list-groups)
    nil
  (defun gnus-group-list-groups (x)
    (gnus-Group-list-groups x)))
;;
;;

;; Emacs 18 don't have member?
(if (fboundp 'member)
    nil
  (defun member (x list)
    (cond
     ((eq list nil) nil)
     ((equal x (car list)) t)
     (t (member x (cdr list))))))

;;
;;
(if (string-match "^18" emacs-version)
    (setq gnus-group-prepare-hook 'lspool-write-board-title
	  gnus-Group-prepare-hook 'lspool-write-board-title
	  gnus-group-update-group-hook 'lspool-write-board-title-one-line
	  gnus-Group-update-group-hook 'lspool-write-board-title-one-line
	  gnus-exit-gnus-hook 'lspool-delete-newsgroups
	  gnus-Exit-gnus-hook 'lspool-delete-newsgroups)
  (require 'gnus)
  (add-hook 'gnus-group-prepare-hook 'lspool-write-board-title)
  (add-hook 'gnus-group-update-group-hook 'lspool-write-board-title-one-line)
  (add-hook 'gnus-exit-gnus-hook 'lspool-delete-newsgroups)
  (defun gnus-article-set-mode-line ()
    "Set Article mode line string.
If you don't like it, define your own gnus-article-set-mode-line."
    (let ((maxlen 15)			;Maximum subject length
	  (subject
	   (if gnus-current-headers
	       (nntp-header-subject gnus-current-headers) "")))
      ;; The value must be a string to escape %-constructs because of subject.
      (setq mode-line-buffer-identification
	    (format "GNUS: %s%s %s%s%s"
		    gnus-newsgroup-name
		    (if gnus-current-article
			(format "/%d" gnus-current-article) "")
		    (lspool-mc-substring subject (min (length subject) maxlen))
		    (if (> (length subject) maxlen) "..." "")
		    (make-string (max 0 (- 17 (length subject))) ? )
		    )))
    (set-buffer-modified-p t)))

;; multi-lingual subject
(defun gnus-optional-from (header)
  (lspool-mc-substring
   (concat (nntp-header-from header) (make-string 30 ? ))
   30))

(defun lspool-write-board-title ()
  (if lspool-display-board-title
      (let ((board-list lspool-board-title-list)
	    (title-position (1- lspool-board-title-position))
	    newsgroup
	    board-title)
	(while board-list
	  (save-excursion
	    (setq newsgroup (car (car board-list)))
	    (setq board-title (car (cdr (car board-list))))
	    (setq board-list (cdr board-list))
	    (goto-char (point-min))
							 ; $B6K$a$FIT==J,(B
							 ; $B=$@5$,I,MW(B
	    (if (re-search-forward (concat newsgroup "$") nil t)
		(progn
		  (while ( < (current-column) title-position)
		    (insert " "))
		  (insert " " board-title))))))))

(defun lspool-write-board-title-one-line ()
  (if lspool-display-board-title
      (save-excursion
	(save-restriction
	  (let (end)
	    (forward-line 1)
	    (setq end (point))
	    (forward-line -1)
	    (narrow-to-region (point) end)
	    (lspool-write-board-title))))))

;;;
;;; Analyze logfile
;;;

(defun lspool-add-article-list (board-name header-vector start end)
  "lspool-article-list $B$K%"!<%F%#%/%k$rDI2C$9$k!#(B

$B0z?t$O(B BOARD-NAME VECTOR START END

BOARD_NAME $B$OJ8;zNs!#(BARTICLE_START ARTICLE_END $B$O(B
lspool-analysis-buffer $BCf$N%"!<%F%#%/%k$X$N%]%$%s%?(B($B@0?t(B)$B!#(B
HEADER_VECTOR $B$O(B nntp-retrieve-headers $B$NJV$9%Y%/%H%k$HF1$8J*!#(B"
  (setq board-name (regulate-board-name board-name))
  (let ((board (gnus-gethash board-name lspool-article-hashtb))
	article-no article)
    (if board
	nil
      (setq board (gnus-make-hashtable 509)))
    (setq article-no (elt header-vector 0))
    (if article-no					 ; if article-no is nil
	nil						 ; use max article-no + 1
      (let (article-no-list)
	(mapatoms (function 
		   (lambda (x)
		     (setq article-no-list
			   (cons (string-to-int (symbol-name x))
				 article-no-list))))
		  board)
	(setq article-no (1+ (apply 'max 0 article-no-list))))
      (aset header-vector 0 article-no)
      (if (elt header-vector 6)				 ; if message-id is nil
	  nil						 ; make message-id
	(aset header-vector 6
	      (concat "<" (int-to-string article-no) "#"
		      board-name "@" lspool-host-name ">"))))
    (if (gnus-gethash (int-to-string article-no) board)
	nil
      (setq article (list header-vector start end))
      (gnus-sethash (int-to-string article-no) article board)
      (if lspool-use-article-list-id
	  (gnus-sethash (elt header-vector 6) article 
			lspool-article-hashtb-by-id))
      (gnus-sethash board-name board lspool-article-hashtb))))

(defun lspool-add-board-title-list (board-name board-title)
  "lspool-board-title-list $B$K(B (NEWSGROUP BOARD_TITLE)
$B$rDI2C$9$k!#(B"
  (let ((board (assoc (regulate-board-name board-name) lspool-board-title-list)))
    (if board
	nil
      (setq lspool-board-title-list
	    (cons (list (regulate-board-name board-name) board-title)
		  lspool-board-title-list)))))

(defun lspool-get-board-title (newsgroup)
  "NEWSGROUP $B$N%\!<%I%?%$%H%k$rJV$9!#(B"
  (let ((board (assoc newsgroup lspool-board-title-list)))
    (if board
	(car (cdr board)))))

(defun lspool-mc-substring (string len)
  (let ((curbuf (current-buffer))
	(tempbuf (generate-new-buffer " *substring-work*"))
	(result))
    (set-buffer tempbuf)
    (erase-buffer)
    (insert string)
    (move-to-column len)
    (if (> (current-column) len)
	(forward-char -1))
    (setq result (buffer-substring (point-min) (point)))
    (if (< (current-column) len)
	(setq result (concat result " ")))
    (set-buffer curbuf)
    (kill-buffer tempbuf)
    result))

(defun lspool-match-current-lines (regexp n)
  "point $B$N$"$k9T$+$i!"(BN $B9T8e$^$G$NHO0O$K(B REGEXP $B$,4^$^$l$k$+$I(B
$B$&$+$r!"(Bre-search-forward $B$r;H$C$FD4$Y!"$=$N7k2L$rJV$9!#(B"
  (let (i)
    (forward-line n)
    (setq i (point))
    (forward-line (- n))
    (re-search-forward regexp i t)))

(defun lspool-match-buffer-substring (i)
  (if (match-beginning i)
      (buffer-substring (match-beginning i) (match-end i))
    ""))

(defun lspool-match-substring (s i)
  (if (match-beginning i)
      (substring s (match-beginning i) (match-end i))
    ""))

(defun lspool-get-string-from-header (header start end)
  (goto-char start)
  (if (re-search-forward header end t)
      (progn
	(setq start (point))
	(forward-line 1)
	(while (looking-at "[ \t]")
	  (forward-line 1))
	(buffer-substring start (1- (point))))))

(defun regulate-board-name (board-name)
  "GNUS $B$N$"$D$+$&(B newsgroup $BL>$H$7$FLdBj$N$"$kJ8;zNs$r(B
$BLdBj$,5/$3$i$J$$MM$KJQ49$9$k!#(B"
  (let ((index (string-match ":" board-name)))
    (if index
	(concat
	 (substring board-name 0 index)
	 "."
	 (regulate-board-name (substring board-name (1+ index))))
      board-name)))

(defun lspool-add-analyze-board-list (start-point board-name)
  "POINT $B$H(B BOARD_NAME $B$r(B $BJQ?t(B lspool-analyze-board-list $B$KDI2C$9$k(B"
  (setq lspool-analyze-board-list
	(append lspool-analyze-board-list 
		(list (list start-point (regulate-board-name board-name))))))

(defun lspool-get-board-from-point (analyze-point)
  "$B%"!<%F%#%/%k$N%X%C%@$K%\!<%IL>$r4^$^$J$$%m%0$r2r@O$9$k;~!"(B
$B%m%02r@O$h$&%P%C%U%!$N(B POINT $B$N;~E@$G$N%\!<%IL>$rJV$9(B"
  (if (and  lspool-analyze-board-list
	    (> analyze-point (car (car lspool-analyze-board-list))))
      (while (and lspool-analyze-board-list
		  (> analyze-point (car (car lspool-analyze-board-list))))
	(setq lspool-analyze-current-board
	      (car (cdr (car lspool-analyze-board-list))))
	(setq lspool-analyze-board-list (cdr lspool-analyze-board-list))))
  lspool-analyze-current-board)

;;;
;;; NET COCK
;;;

(defvar boardtitle-regexp-netcock-1 "^No\\.[0-9]+ (I"(B\\(.*\\)(I#(B$")
(defvar boardtitle-regexp-netcock-2 
      "^\\([^ \\(\\)]+\\)\\((\\([0-9]+\\)/[0-9]+)\\)? \
[0-9][0-9]/[0-9][0-9]/[0-9][0-9] [0-9][0-9]:[0-9][0-9]")

;;(defvar header-regexp-netcock-1 "^\C-[\\[32m-")
(defvar header-regexp-netcock-1 "^\C-[?\\[32m-")
(defvar header-regexp-netcock-2
      "^\\([^ \\(\\)]+\\)\\((\\([0-9]+\\)/[0-9]+)\\)? \
\\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] [0-9][0-9]:[0-9][0-9]\\) \\(.*\\)$")
(defvar header-regexp-netcock-3 "^ <\\([0-9]+\\):.*\\(/[0-9]+\\):\\(.*\\)>$")
(defvar header-regexp-netcock-4 "^  .* \\([0-9]+\\):\\(.*\\) $")
;;(defvar terminal-regexp-netcock-1 "^\C-[\\[3[0-9]m\\($BFI$_=*(B\\|-\C-i-\\|$B%P%C%A(B\\)")
(defvar terminal-regexp-netcock-1 "^\C-[?\\[3[0-9]m\\($BFI$_=*(B\\|-\C-i-\\|$B%P%C%A(B\\)")

(defun lspool-analyze-logfile-netcock ()
  (message "Analyzing ...")
  (save-excursion
    (let (user-id user-name board-name article-no re-article-no board-title
	  board-no subject date start j status)
      (set-buffer lspool-analysis-buffer)
      (save-excursion					 ; analyze board-title
	(while (re-search-forward boardtitle-regexp-netcock-1 nil t)
	  (setq board-title (buffer-substring (match-beginning 0) (match-end 0)))
	  (forward-line 3)
	  (if (lspool-match-current-lines boardtitle-regexp-netcock-2 1)
	      (progn
		(setq board-name (buffer-substring (match-beginning 1) (match-end 1)))
		(lspool-add-board-title-list
		 (concat lspool-host-name "." board-name)
		 board-title))
	    (forward-line -2))))
      (while (re-search-forward  header-regexp-netcock-1 nil t)	; analyze article
	(setq status t)
        (forward-line 1)
	(if (lspool-match-current-lines header-regexp-netcock-2 1)
	    (progn
	      (forward-line 0)
	      (setq start (point))
	      (setq board-name (buffer-substring (match-beginning 1) (match-end 1)))
	      (setq article-no				 ; mail have no article-no
		    (if (match-beginning 2)
			(string-to-int (buffer-substring (match-beginning 3) (match-end 3)))
		      nil))
	      (setq date (buffer-substring (match-beginning 4) (match-end 4)))
	      (setq subject (buffer-substring (match-beginning 5) (match-end 5)))
	      (forward-line 1))
	  (setq status nil))
	(if (and status (lspool-match-current-lines header-regexp-netcock-3 1))
	    (progn
	      (setq re-article-no (string-to-int
				   (buffer-substring
				    (match-beginning 1) (match-end 1))))
	      (forward-line 1))
	  (setq re-article-no nil))
	(if (and status (lspool-match-current-lines header-regexp-netcock-4 1))
	    (progn
	      (setq user-id (buffer-substring (match-beginning 1) (match-end 1)))
	      (setq user-name (buffer-substring (match-beginning 2) (match-end 2))))
	  (setq status nil))
	(if (and status (re-search-forward terminal-regexp-netcock-1 nil t))
	    (progn
	      (forward-line 0)
	      (setq j (point))
	      (message "Analyzing ... %s"  board-name)
	      (lspool-add-article-list
	       (concat lspool-host-name "." board-name)
	       (vector
		article-no				 ; article
		subject					 ; subject
		(concat user-id "@" lspool-host-name	 ; from
			" (" user-name ")")
		nil					 ; Xref
		(count-lines start j)			 ; lines
		date					 ; date
		(if article-no				 ; message-id
		    (concat "<" (int-to-string article-no) "#"
			    board-name "@" lspool-host-name ">")
		  nil)
		(if re-article-no			 ; references
		    (concat "<" re-article-no "#"
			    board-name "@" lspool-host-name ">")))
	       start j)
	      (forward-line -1))))))
  (message "done."))

;;;
;;; Nifty          by kent
;;;
;   $BBP>](B
;       $BDL>o2q5D<<(B
;       $BDL>o(Bmail
;       Internet mail
;
;       HP$B$OMxMQ$7$F$J$$$N$GCN$i$s(B
;       inetnews$B$bMxMQ$7$F$J$$$N$GCN$i$s(B
;
;       $B2q5D<<$X$N(B follow $B$OBg>fIW$_$?$$(B
;       $B2q5D<<$X$N(B reply mail $B$bBg>fIW$_$?$$(B
;       mail $B$X$N(B reply mail $B$bBg>fIW$_$?$$(B
;       Internet mail $B$X$N(B reply $B$,$X$s(B

(defvar date-regexp-nifty-1 "[0-9][0-9]/[0-9][0-9]/[0-9][0-9] [0-9][0-9]:[0-9][0-9]")
(defvar id-regexp-nifty-1 "[A-Z][A-Z][A-Z][0-9][0-9][0-9][0-9][0-9]")
;       1:forum name  2:board-no  3:board name
(defvar boardtitle-regexp-nifty-1 "^- \\([A-Z0-9]+\\) +MES( *\\([0-9]+\\)):\\(.+\\)[0-9][0-9]/[0-9][0-9]/[0-9][0-9] -")
;       1:user-name  2:user-id  3:date  4:subject
(defvar mail-regexp-nifty-1 (concat "^ *[0-9]+ +\\(.*\\) +\\(" id-regexp-nifty-1 "\\) +\\(" date-regexp-nifty-1 "\\)\n    $BBjL>!'(B\\(.*\\)$"))
;       1:article-no  2:user-id  3:user-name  4:subject
(defvar header-regexp-nifty-1 (concat "^\\([0-9]+\\)/[0-9]+ +\\(" id-regexp-nifty-1 "\\) +\\(.+\\)[ $B!!(B]+\\(.*\\)$"))
;       1:board-no  2:date time      3:re-article-no
(defvar header-regexp-nifty-2 (concat "^( *\\([0-9]+\\)) +\\(" date-regexp-nifty-1 "\\)\\(    .*\\|\\)$"))
(defvar header-regexp-nifty-3 (concat "^( *\\([0-9]+\\)) +\\(" date-regexp-nifty-1 "\\) +\\([0-9]+\\)$B$X$N%3%a%s%H(B"))
(defvar terminal-regexp-nifty-1-l (concat "^\\(\\([0-9]+\\)/[0-9]+ +" id-regexp-nifty-1 " +.+\n("))
(defvar terminal-regexp-nifty-1-r (concat ") +" date-regexp-nifty-1 "\\|$B!d"!<!JG$O$"$j$^$;$s"!(B\\|- [A-Z0-9]+ +MES(\\|action:\\|$B<u?.8e(B (1:\\|Clear PAD.*\nHost requested clearing the call\\| *[0-9]+ +.* +" id-regexp-nifty-1 " +" date-regexp-nifty-1 "\n    $BBjL>!'(B\\)"))

(defun lspool-2digit (n)				 ; $B2?$+$7$i<jCJ$O$"$k$s$@$m$&$1$I(B lisp $B$O$h$/CN$i$J$$$+$i<+:n(B
  (cond ((stringp n) (cond ((< (string-to-int n) 10) (concat "0" n))
			   (t n)))
	(t (cond ((< n 10) (concat "0" (int-to-string n)))
		 (t (int-to-string n))))))

							 ; $B$3$$$D$r8F$V$H(B match-(beginning|end) $B$,>C$($k(B(^^;
(defun lspool-omit-edge-space (s)
  (if (stringp s)
      (if (string-match "[ $B!!(B]*\\([^ $B!!(B]+\\([ $B!!(B]+[^ $B!!(B]+\\)*\\)[ $B!!(B]*" s)
	  (lspool-match-substring s 1)
	s)
    nil))

(defun lspool-analyze-logfile-nifty ()
  (message "Analyzing ...")
  (save-excursion
    (let (user-id user-name board-name article-no re-article-no board-title
	  board-no subject date start j status tempstr tempstr2 (old-article-no -1) (old-board-no -1))
      (set-buffer lspool-analysis-buffer)
      (save-excursion					 ; analyze board-title
	(lspool-add-board-title-list "nifty.mail" "$B$*$F$,$_(B")
	(while (re-search-forward boardtitle-regexp-nifty-1 nil t)
	  (setq board-title (lspool-match-buffer-substring 3))	 ; string
	  (setq board-name (concat (downcase (lspool-match-buffer-substring 1))
				   "."
				   (lspool-2digit (lspool-match-buffer-substring 2))))
	  (lspool-add-board-title-list
	   (concat lspool-host-name "." board-name)
	   board-title)
	  (forward-line 1)))

      (while (re-search-forward
	      (concat "\\(" boardtitle-regexp-nifty-1	 ; 2 3 4
		      "\\|" header-regexp-nifty-1	 ; 5 6 7 8
		      "\\|" mail-regexp-nifty-1		 ; 9 10 11 12
		      "\\)") nil t)
	(setq state nil)
	(cond ((match-end 2)				 ; board title
	       (setq board-title (lspool-match-buffer-substring 3))	 ; number in string
	       (setq board-name (concat (downcase (lspool-match-buffer-substring 2)) "." (lspool-2digit board-title)))
	       (setq board-no (string-to-int board-title))
	       (forward-line 1))
	      (t
	       (cond

		((match-end 9)				 ; mail
		 (setq board-no 0
		       article-no nil
		       re-article-no nil)
		 (forward-line -2)			 ; $B@55,I=8=$N%^%C%A%s%0$G5-21$5$l$kNN0h$O$O(B9$B8D$^$G$J$N$G!"$b$&(B1$B2s$d$k(B
		 (if (not (re-search-forward mail-regexp-nifty-1 nil t))
		     (yes-or-no-p "$B$3$N%W%m%0%i%`$+%m%0%U%!%$%k$,$*$+$7$$$h$J!*(B"))
		 (setq board-name "mail")
		 (setq user-id (lspool-match-buffer-substring 2))
		 (setq subject (lspool-match-buffer-substring 4))
		 (setq date (lspool-match-buffer-substring 3))
		 (setq user-name (lspool-omit-edge-space (lspool-match-buffer-substring 1)))
		 (if (and (string-match "INET GATE.*" user-name)
			  (lspool-match-current-lines "^From: \\(.*\\)<\\([^>]+\\)>$" 5))
		     (progn
		       (setq state 'internet-mail)
		       (setq user-id (lspool-match-buffer-substring 2))
		       (setq user-name (lspool-omit-edge-space (lspool-match-buffer-substring 1))))
		   (setq state 'mail))
		 (forward-line 1)
		 )

		((match-end 5)				 ; mes
		 (setq article-no (string-to-int (lspool-match-buffer-substring 5)))
		 (setq user-id (lspool-match-buffer-substring 6))
							 ; handle $B$H(B subject $B$rJ,$1$k(B
							 ; $B6uGr$N=|5n$,LLE](B
		 (setq tempstr (code-convert-string (buffer-substring (match-beginning 7) (match-end 1)) *internal* *sjis*))
		 (if (>= (length tempstr) 16)
		     (progn
		       (setq tempstr2 (code-convert-string (substring tempstr 16) *sjis* *internal*))
		       (setq tempstr (code-convert-string (substring tempstr 0 16) *sjis* *internal*))
		       (if (string-match "\\([^ $B!!(B]+\\([ $B!!(B]+[^ $B!!(B]+\\)*\\)[ $B!!(B]+" tempstr)
			   (setq user-name (lspool-match-substring tempstr 1))
			 (setq user-name tempstr))
		       (string-match " *\\(.*\\) *" tempstr2)
		       (setq subject (lspool-match-substring tempstr2 1))

		       (setq date "$B$3$l$,8+$($k$H$$$&$N$O$J$s$+JQ$@$>(B")
		       (setq re-article-no nil)
		       (forward-line 1)			 ; header $B$N(B2$B9TL\$H(Bmatching
		       (cond ((lspool-match-current-lines header-regexp-nifty-2 3)
			      (forward-line 0)
			      (setq state 'mes)
			      (setq date (lspool-match-buffer-substring 2))
			      (forward-line 1))
			     ((progn (forward-line -2) (lspool-match-current-lines header-regexp-nifty-3 3))
			      (setq state 'mes)
			      (setq date (lspool-match-buffer-substring 2))
			      (setq re-article-no (string-to-int (lspool-match-buffer-substring 3)))
			      (forward-line 1))
			     (t (message "                         Illegal header ... $B$@$1$IB39T(B")
				(forward-line 3)))))))

							 ; mail or mes
	       (if (eq state 'mes)
		   (progn
		     (if (and (eq state 'mes) (eq old-board-no board-no) (>= old-article-no article-no))
			 (progn
			   (message "$B5-;v5UE>$N2DG=@-$"$j(B  $B$G$bB39T(B")
			   (sleep-for 3)))
		     (setq old-board-no board-no
			   old-article-no article-no)))
	       (setq start (point))
	       (if (and state (re-search-forward (concat terminal-regexp-nifty-1-l (format "%2d" board-no) terminal-regexp-nifty-1-r) nil t))
		   (progn
		     (forward-line (if (or (match-end 2) (match-end 3)) -1 0))
		     (setq j (point))
		     (message "Analyzing ... %s %d"  board-name (if article-no article-no 0))
		     (lspool-add-article-list
		      (concat lspool-host-name "." board-name)
		      (vector
		       article-no			 ; article
		       subject				 ; subject
							 ; from
		       (cond ((eq state 'internet-mail)
			      (concat user-id " (" user-name ")"))
			     (t
			      (concat user-id "@"	 ; "@niftyserve.or.jp"
				      lspool-host-name
				      " (" user-name ")")))
		       nil				 ; Xref
		       (count-lines start j)		 ; lines
		       date				 ; date
		       (if article-no			 ; message-id
			   (concat "<" (int-to-string article-no) "#"
				   board-name "@" lspool-host-name ">"))
		       (if re-article-no		 ; references
			   (concat "<" (int-to-string re-article-no) "#"
				   board-name "@" lspool-host-name ">")))
		      start j)
		     (forward-line -1))))))))
  (message "done."))

;;;
;;; MuHost
;;;

(defvar boardtitle-regexp-muhost-1 "^$B!N(B \\([A-Z0-9]+\\) ([/0-9]+) $B$K0\F0$7$^$9!#!O(B\
\\|^\\([A-Z0-9\\-]+\\) ?([/0-9]+) (Write,\
\\|^NOTE (Write,Answer,List,Delete,Help,End) \\[\\([0-9]+\\)-[0-9]+\\] :")
(defvar header-regexp-muhost-1 "^$BHV9f(B $BAw?.<T(B   $BAw?.<TL>(B   $BAw?.F|(B  $B;~9o(B  $B%?%$%H%k(B\
\\|\\(^$BHV9f(B  $BAw?.<T(B   $BAw?.<TL>(B   $BAw?.F|(B    $B;~9o(B    $B%?%$%H%k(B\\)")
(defvar header-regexp-muhost-2
      "^ *\\([0-9]+\\) sun\\([0-9]+\\) \\(.*\\) \\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] \
[0-9][0-9]:[0-9][0-9]\\) \\(.*[^ ]\\) +\\([0-9]+\\)$")
(defvar header-regexp-muhost-3 "^Re\\([0-9]+\\):.*")
(defvar header-regexp-muhost-4 "< $B7G<(J*$N%j%9%H(B >\n\\|< $B<u?.%a!<%k$N%j%9%H(B >\n")
(defvar header-regexp-muhost-5
      "^[ \*]*\\([0-9]+\\) sun\\([0-9]+\\) \\(.*\\) \\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] \
[0-9][0-9]:[0-9][0-9]:[0-9][0-9]\\) \\(.*[^ ]\\) +$")
(defvar terminal-regexp-muhost-1 "^$BHV9f(B $BAw?.<T(B   $BAw?.<TL>(B   $BAw?.F|(B  $B;~9o(B  $B%?%$%H%k(B\
\\|^$BHV9f(B  $BAw?.<T(B   $BAw?.<TL>(B   $BAw?.F|(B    $B;~9o(B    $B%?%$%H%k(B\
\\|^$B$b$&?7$7$$%G!<%?$O$"$j$^$;$s!#(B\
\\|^\\[ $B%P%$%J%j%U%!%$%k(B \\]\
\\|^NOTE (Write,\
\\|^MAIL(/7) (Write,"
)
;"
;; $BK\Ev$O$3$l$bI,MW$@$,!"L5;k$9$k!#(B
;;\\|^ *\\([0-9]+\\) sun\\([0-9]+\\) \\(.*\\) \\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] \
;;[0-9][0-9]:[0-9][0-9]\\) \\(.*\\) +\\([0-9]+\\)$")

(defun lspool-analyze-logfile-muhost ()
  (message "Analyzing ...")
  (save-excursion
    (let (article-no user-id user-name board-name date re-article-no
	  line-no subject start j status)
      (set-buffer lspool-analysis-buffer)
      (save-excursion					 ; analyze board title
	(setq lspool-analyze-board-list nil)
	(setq lspool-analyze-current-board nil)
	(while (re-search-forward boardtitle-regexp-muhost-1 nil t)
	  (cond ((match-beginning 3)
		 (lspool-add-analyze-board-list
		  (point)
		  (concat lspool-analyze-current-board "."
			  (buffer-substring (match-beginning 3) (match-end 3)))))
		((match-beginning 1)
		 (setq lspool-analyze-current-board
		       (buffer-substring (match-beginning 1) (match-end 1)))
		 (lspool-add-analyze-board-list (point) lspool-analyze-current-board))
		((match-beginning 2)
		 (setq lspool-analyze-current-board
		       (buffer-substring (match-beginning 2) (match-end 2)))
		 (if (string-match "-\\([^\\-]+\\)$" lspool-analyze-current-board)
		     (setq lspool-analyze-current-board
			   (substring lspool-analyze-current-board
				      (match-beginning 1) (match-end 1))))
		 (lspool-add-analyze-board-list (point) lspool-analyze-current-board)))))

	(setq lspool-analyze-current-board nil)		 ; analyze article
	(while (re-search-forward header-regexp-muhost-1 nil t)
	  (forward-line 0)
	  (setq start (point))
	  (if (match-beginning 1)
	      (setq status 'mail)
	    (setq status 'news))
	  (forward-line -1)
	  (if (lspool-match-current-lines header-regexp-muhost-4 1)
	      (setq status nil))
	  (forward-line 2)
	  (if (cond ((eq status 'news)
		     (lspool-match-current-lines header-regexp-muhost-2 1))
		    ((eq status 'mail)
		     (lspool-match-current-lines header-regexp-muhost-5 1))
		    (t nil))
	      (progn
		(setq article-no (string-to-int
				  (buffer-substring (match-beginning 1) (match-end 1))))
		(setq user-id (buffer-substring (match-beginning 2) (match-end 2)))
		(setq user-name (buffer-substring (match-beginning 3) (match-end 3)))
		(setq date (buffer-substring (match-beginning 4) (match-end 4)))
		(setq subject (buffer-substring (match-beginning 5) (match-end 5)))
;		  (setq line-no (string-to-int
;				 (buffer-substring (match-beginning 6) (match-end 6))))
		(setq board-name (lspool-get-board-from-point (point))))
	    (setq status nil))
	  (if (and status (string-match header-regexp-muhost-3 subject))
	      (setq re-article-no
		    (substring subject (match-beginning 1) (match-end 1)))
	    (setq re-article-no nil))
	  (if (and status (re-search-forward terminal-regexp-muhost-1 nil t))
	      (progn
		(forward-line 0)
		(setq j (point))
		(message "Analyzing ... %s"  board-name)
		(lspool-add-article-list
		 (concat lspool-host-name "." board-name)
		 (vector
		  article-no				 ; article
		  subject				 ; subject
		  (concat user-id "@" lspool-host-name	 ; from
			  " (" user-name ")")
		  nil					 ; Xref
		  (count-lines start j)			 ; lines
		  date					 ; date
		  (concat "<" (int-to-string article-no) "#" ; message-id
			  board-name "@" lspool-host-name ">")
		  (if re-article-no			 ; references
		      (concat "<" re-article-no "#"
			      board-name "@" lspool-host-name ">")))
		 start j))))))
  (message "done."))

;;;
;;; Netnews in rmail format
;;;

(defun lspool-analyze-logfile-rmail-netnews ()
  (message "Analyzing ... ")
  (setq lspool-insert-news-headers nil)
  (save-excursion
    (let (line-no from board-name newsgroups message-id references
	  subject date start i j)
      (set-buffer lspool-analysis-buffer)
      (while (re-search-forward "\C-L" nil t)
	(setq i (point))
	(re-search-forward "^\\*\\*\\* EOOH \\*\\*\\*\n" nil t)
	(setq start (point))
	(search-forward "\n\n")
	(setq j (point))
	(goto-char i)
	(setq from (lspool-get-string-from-header "^From: " i j))
	(setq subject (lspool-get-string-from-header "^Subject: " i j))
	(setq date (lspool-get-string-from-header "^Date: " i j))
	(setq message-id (lspool-get-string-from-header "^Message-id: " i j))
	(setq references (lspool-get-string-from-header "^References: " i j))
	(goto-char i)
	(if (re-search-forward "^Newsgroups: " j t)
	    (progn
	      (setq newsgroups nil)
	      (while (progn
		       (setq j (point))
		       (re-search-forward "[,\n]")
		       (setq newsgroups (cons (buffer-substring j (1- (point))) newsgroups))
		       (equal (char-before (point)) 44   ; (string-to-char ",")
			      )))
	      (search-forward "\n\C-_")
	      (forward-char -1)
	      (setq j (point))
	      (while newsgroups
		(setq board-name (car newsgroups))
		(setq newsgroups (cdr newsgroups))
		(message "Analyzing ... %s"  board-name)
		(lspool-add-article-list
		 (concat lspool-host-name "." board-name)
		 (vector
		  nil					 ; article
		  subject				 ; subject
		  from					 ; from
		  nil					 ; Xref
		  (count-lines start j)			 ; lines
		  date					 ; date
		  message-id				 ; message-id
		  references)				 ; references
		  start j)))))))
  (message "done."))

;;;
;;; Mapletown Network
;;;

;;
;; $BFs$D$N4X?t$O$H$j$"$($:$NJ*$G!"$9$0$KGQ;_$5$l$k!#(B
;;

(defvar lspool-board-name-list nil)

(defun lspool-add-board-name-list (board-no board-name)
  (let ((board (assoc board-no lspool-board-name-list)))
    (if board
	nil
      (setq lspool-board-name-list
	    (cons (list board-no (downcase board-name))
		  lspool-board-name-list)))))

(defun lspool-get-board-name (board-no)
  (let ((board (assoc board-no lspool-board-name-list)))
    (if board
	(car (cdr board))
      board-no)))

(defvar boardtitle-regexp-maple-1 "^\\(#[0-9]+\\) (#\\([^)]+\\)) \
\\|^  No\\. poster name and ID       date   keyword   line subject")
(defvar boardtitle-regexp-maple-2 "^#\\([0-9]+\\) \\(.*[^ ]\\) +article No")

(defvar header-regexp-maple-1 "^Article \\([0-9]+\\) of [0-9]+ in \\(#[0-9]+\\) \
\\(.*\\) \\[.*\\]$\
\\|^Mail [0-9]+ of [0-9]+ (serial No.\\([0-9]+\\))$\
\\|^Profile of \\(.*\\) *(MAP\\([0-9]+\\)) *$")
(defvar header-regexp-maple-2 "^Posted at \\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] [0-9][0-9]:\
[0-9][0-9]:[0-9][0-9]\\) by \\(.*\\) *(MAP\\([0-9]+\\)) *(\\([0-9]+\\) lines?)$")
(defvar header-regexp-maple-3 "^Subject: \\(.*\\)$")
(defvar header-regexp-maple-4  "^Re:\\*[0-9]+ \\(.+\\) /\\([0-9]+\\)\\((#[0-9]+)\\)? \\.+ \
/\\([0-9]+\\)\\((#[0-9]+)\\)? /\\([0-9]+\\)\\(\\((#[0-9]+)\\)?\\) *$")
(defvar header-regexp-maple-5  "^Re: Re: Re: \\(.+\\) /\\([0-9]+\\)\\((#[0-9]+)\\)? \
/\\([0-9]+\\)\\((#[0-9]+)\\)? /\\([0-9]+\\)\\(\\((#[0-9]+)\\)?\\) *$")
(defvar header-regexp-maple-6  "^Re: Re: \\(.+\\) \
/\\([0-9]+\\)\\((#[0-9]+)\\)? /\\([0-9]+\\)\\(\\((#[0-9]+)\\)?\\) *$")
(defvar header-regexp-maple-7  "^Re: \\(.+\\) /\\([0-9]+\\)\\(\\((#[0-9]+)\\)?\\) *$")
(defvar header-regexp-maple-8  "^command\\[")
(defvar header-regexp-maple-9
"^From \\(.*\\) *(MAP\\([0-9]+\\)) *(\\([0-9]+\\) lines?)$")
(defvar header-regexp-maple-10 "^Posted at \\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] [0-9][0-9]:\
[0-9][0-9]:[0-9][0-9]\\)")
(defvar header-regexp-maple-11 "^\\(No\\.\\([0-9]+\\) of [0-9]+ (DATE) \\)?registered at \
\\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] [0-9][0-9]:[0-9][0-9]:[0-9][0-9]\\)")
(defvar header-regexp-maple-12 "^Multiposted to\\(.*\\)$")
(defvar header-regexp-maple-13 "[^0-9]\\([0-9]+\\)(#\\([^)]+\\))")
(defvar header-regexp-maple-14 "^ +[0-9]+")
(defvar header-regexp-maple-15 "^ +\\([0-9]+\\) \\(.*\\) *(MAP\\([0-9]+\\)) *\
\\([0-9][0-9]/[0-9][0-9]/[0-9][0-9]\\) ......... +[0-9]+ \\(.*\\)$")

(defvar terminal-regexp-maple-1  "^\C-[\\[\\(7;\\)?0m\\|<CTRL-C>")
;;(defvar terminal-regexp-maple-1
;;"^\C-[\\[\\(7;\\)?0m\\|<CTRL-C>\\|^Article\\|^Mail\\|^<BBS>\\|^Profile")

(defun lspool-analyze-logfile-maple ()
  (message "Analyzing ...")
  (save-excursion
    (let (line-no user-id user-name board-name board-no article-no reference-no-list xref
	  multipost-list reference-board-list subject date board-title start j status)
      (set-buffer lspool-analysis-buffer)
      ;;
      ;; analyze board-title
      ;; and header only article
      (save-excursion
	(setq lspool-board-name-list nil)
	(while (re-search-forward boardtitle-regexp-maple-1 nil t)
	  (cond 
	   ((match-beginning 1)			 ; board-title
	    (lspool-add-board-name-list
	     (buffer-substring (match-beginning 1) (match-end 1))
	     (buffer-substring (match-beginning 2) (match-end 2))))
	   (t					 ; header only article
	    (setq status t)
	    (forward-line -2)
	    (if (lspool-match-current-lines boardtitle-regexp-maple-2 2)
		(progn
		  (setq board-no (buffer-substring (match-beginning 1) (match-end 1)))
		  (setq board-title (buffer-substring (match-beginning 2) (match-end 2))))
	      (setq status nil))
	    (forward-line 3)
	    (while (and status (lspool-match-current-lines header-regexp-maple-14 1))
	      (forward-line 0)
	      (setq start (point))
	      (if (lspool-match-current-lines header-regexp-maple-15 1)
		  (progn
		    (setq j (point))
		    (setq article-no (string-to-int
				      (buffer-substring (match-beginning 1) (match-end 1))))
		    (setq user-name  (buffer-substring (match-beginning 2) (match-end 2)))
		    (setq user-id  (buffer-substring (match-beginning 3) (match-end 3)))
		    (setq date (buffer-substring (match-beginning 4) (match-end 4)))
		    (setq subject (buffer-substring (match-beginning 5) (match-end 5)))
		    (setq line-no 1)
		    (lspool-add-board-title-list
		     (concat lspool-host-name "." board-no)
		     board-title)
		    (lspool-add-article-list
		     (concat lspool-host-name "." board-no)
		     (vector
		      article-no			 ; article
		      subject				 ; subject
		      (concat user-id "@" lspool-host-name ; from
			      " (" user-name ")")
		      nil				 ; Xref
		      1					 ; lines
		      date				 ; date
		      (concat "<" (int-to-string article-no) "#" ; message-id
			      board-name "@" lspool-host-name ">")
		      nil)				 ; references
		     start j)))
	      (forward-line 1))))))
      ;;
      ;; analyze article
      ;;
      (while (re-search-forward header-regexp-maple-1 nil t)
	(setq status t)
	(setq multipost-list nil)
	(setq xref nil)
	(forward-line 0)
	(setq start (point))
	(cond
	 ((match-beginning 1)
	  (setq status 'news)
	  (setq article-no (string-to-int
			    (buffer-substring (match-beginning 1) (match-end 1))))
	  (setq board-no (buffer-substring (match-beginning 2) (match-end 2)))
	  (setq board-name (lspool-get-board-name board-no))
	  (setq board-title 
		(concat (buffer-substring (match-beginning 3) (match-end 3))
			" (" board-no ")")))
	 ((match-beginning 4)
	  (setq status 'mail)
	  (setq article-no (string-to-int
			    (buffer-substring (match-beginning 4) (match-end 4)))))
	 (t
	  (setq status 'profile)
	  (setq user-name  (buffer-substring (match-beginning 5) (match-end 5)))
	  (setq user-id  (buffer-substring (match-beginning 6) (match-end 6)))))
	(forward-line 1)
	(cond
	 ;;
	 ;; news
	 ;;
	 ((eq status 'news)
	  (if (lspool-match-current-lines header-regexp-maple-2 1)
	      (progn
		(setq date (buffer-substring (match-beginning 1) (match-end 1)))
		(setq user-name (buffer-substring (match-beginning 2) (match-end 2)))
		(setq user-id (buffer-substring (match-beginning 3) (match-end 3)))
		(setq line-no (string-to-int
			       (buffer-substring (match-beginning 4) (match-end 4))))
		(forward-line 1))
	    (setq status nil))
	  (if (and status (lspool-match-current-lines header-regexp-maple-3 1))
	      (progn
		(setq reference-no-list nil)
		(forward-line 1)
		(setq subject (buffer-substring (match-beginning 1) (match-end 1)))
		(cond
		 ((or (string-match header-regexp-maple-4 subject)
		      (string-match header-regexp-maple-5 subject))
		  (setq reference-no-list
			(list (substring subject (match-beginning 2) (match-end 2))
			      (substring subject (match-beginning 4) (match-end 4))
			      (substring subject (match-beginning 6) (match-end 6))))
		  (setq reference-board-list 
			(list (lspool-match-substring subject 3)
			      (lspool-match-substring subject 5)
			      (lspool-match-substring subject 7)))
		  (setq subject (substring subject (match-beginning 1) (match-end 1))))
		 ((string-match header-regexp-maple-6 subject)
		  (setq reference-no-list
			(list (substring subject (match-beginning 2) (match-end 2))
			      (substring subject (match-beginning 4) (match-end 4))))
		  (setq reference-board-list
			(list (lspool-match-substring subject 3)
			      (lspool-match-substring subject 5)))
		  (setq subject (substring subject (match-beginning 1) (match-end 1))))
		 ((string-match header-regexp-maple-7 subject)
		  (setq reference-no-list
			(list (substring subject (match-beginning 2) (match-end 2))))
		  (setq reference-board-list
			(list (lspool-match-substring subject 3)))
		  (setq subject (substring subject (match-beginning 1) (match-end 1)))))
		(if reference-no-list
		    (setq reference-board-list
			  (mapcar (function
				   (lambda (reference-board)
				     (if (or (not reference-board)
					     (string= reference-board ""))
					 board-name
				       (lspool-get-board-name
					(substring reference-board
						   1 (1- (length reference-board)))))))
				  reference-board-list))))
	    (setq status nil))
	  (if status
	      (if (lspool-match-current-lines header-regexp-maple-12 1) ; multipost
		  (let (multipost m-board m-article-no)
		    (setq multipost (buffer-substring
				     (match-beginning 1) (match-end 1)))
		    (setq xref (concat "lspool " lspool-host-name "." board-name ":"
				       (int-to-string article-no)))
		    (while (string-match header-regexp-maple-13 multipost)
		      (setq m-article-no (substring multipost (match-beginning 1) (match-end 1)))
		      (setq m-board (downcase
				     (substring multipost (match-beginning 2) (match-end 2))))
		      (setq xref (concat xref " " lspool-host-name "." m-board
					 ":" m-article-no))
		      (setq multipost-list
			    (cons
			     (list (string-to-int m-article-no) m-board)
			     multipost-list))
		      (setq multipost (substring multipost (match-end 2))))))))
	 ;;
	 ;; mail
	 ;;
	 ((eq status 'mail)
	  (if (lspool-match-current-lines header-regexp-maple-9 1)
	      (progn
		(setq board-name "mail")
		(setq board-title "$B%a!<%k(B")
		(setq subject "mail")
		(setq reference-no-list nil)
		(setq user-name (buffer-substring (match-beginning 1) (match-end 1)))
		(setq user-id (buffer-substring (match-beginning 2) (match-end 2)))
		(setq line-no (string-to-int
			       (buffer-substring (match-beginning 3) (match-end 3))))
		(forward-line 1))
	    (setq status nil))
	  (if (lspool-match-current-lines header-regexp-maple-10 1)
	      (setq date (buffer-substring (match-beginning 1) (match-end 1)))
	    (setq status nil)))
	 ;;
	 ;; profile
	 ;;
	 ((eq status 'profile)
	  (if (lspool-match-current-lines header-regexp-maple-11 1)
	      (progn
		(setq board-name "profile")
		(setq board-title "$B%W%m%U%#!<%k(B")
		(setq subject "profile")
		(setq reference-no-list nil)
		(setq article-no
		      (if (match-beginning 1)
			  (progn
			    (string-to-int
			     (buffer-substring (match-beginning 2) (match-end 2))))
			nil))
		(setq date (buffer-substring (match-beginning 3) (match-end 3))))
	    (setq status nil))))
	;;
	;;
	(if status
	    (forward-line 1))
	(if (and status
		 (lspool-match-current-lines header-regexp-maple-8 2)
		 (let ((cpoint (point)))
		   (re-search-forward terminal-regexp-maple-1 nil t)
		   (setq j (point))
		   (goto-char cpoint)
		   (re-search-forward header-regexp-maple-1 j t)))
	    (progn
	      (goto-char start)
	      (forward-line 4)
	      (setq status nil)))
	(if (and status (re-search-forward terminal-regexp-maple-1 nil t))
	    (progn
	      (forward-line 0)
	      (setq j (point))
	      (message "Analyzing ... %s"  board-name)
	      (lspool-add-board-title-list
	       (concat lspool-host-name "." board-name)
	       board-title)
	      (while					 ; repeat until, do while
		  (progn
		    (lspool-add-article-list
		     (concat lspool-host-name "." board-name)
		     (vector
		      article-no				 ; article
		      subject					 ; subject
		      (concat user-id "@" lspool-host-name	 ; from
			      " (" user-name ")")
		      xref					 ; Xref
		      (count-lines start j)			 ; lines
		      date					 ; date
		      (if article-no
			  (concat "<" (int-to-string article-no) "#" ; message-id
				  board-name "@" lspool-host-name ">")
			nil)
		      (if reference-no-list			 ; references
			  (let ((ref "") 
				(ref-no-list reference-no-list)
				(ref-board-list reference-board-list))
			    (while ref-no-list
			      (setq ref
				    (concat ref " <" (car ref-no-list) "#"
					    (car ref-board-list)
					    "@" lspool-host-name ">"))
			      (setq ref-no-list (cdr ref-no-list))
			      (setq ref-board-list (cdr ref-board-list)))
			    ref)))
		     start j)
		    (if multipost-list			 ; roop condition
			(progn
			  (setq board-name (car (cdr (car multipost-list))))
			  (setq article-no (car (car multipost-list)))
			  (setq multipost-list (cdr multipost-list))
			  t))))
	      (forward-line -1))))))
  (message "done."))

;;;
;;; mmm
;;;

(defvar header-regexp-mmm-1 "^Note \\([0-9]+\\) +\\(.*[^ ]\\) +(\\([^ ]*\\))$")
(defvar header-regexp-mmm-2 "^\\[ RESPONSE: +\\([0-9]+\\) of +[0-9]+ \\]$\
\\|^\\[ BASENOTE with +[0-9]+Res \\]$")
(defvar header-regexp-mmm-3 "^Title: \\(.*\\)$")
(defvar header-regexp-mmm-4 "^Subject: \\(.*\\)$")
;;(defvar header-regexp-mmm-5 "^Bytes: [0-9]+ +Date : \\([0-9][0-9]/[0-9][0-9]\
;;/[0-9][0-9] [0-9][0-9]:[0-9][0-9]:[0-9][0-9]\\)  Author: \\([^ ]+\\) +(\\(.*\\))$")
(defvar header-regexp-mmm-5 "^Bytes: [0-9]+ +Date : \\(.*\\)  Author: \\([^ ]+\\) +(\\(.*\\))$")

(defvar terminal-regexp-mmm-1 "^<.*>$\
\\|^Note \\([0-9]+\\) +\\(.*[^ ]\\) +(\\([^ ]*\\))$")

(defun lspool-analyze-logfile-mmm ()
  (message "Analyzing ...")
  (save-excursion
    (let (user-id user-name board-name note-no article-no
	  subject date start j status)
      (set-buffer lspool-analysis-buffer)
      (while (re-search-forward  header-regexp-mmm-1 nil t)
	(setq status t)
	(forward-line 0)
	(setq start (point))
	(setq note-no (buffer-substring (match-beginning 1) (match-end 1)))
	(setq board-name (buffer-substring (match-beginning 3) (match-end 3)))
        (forward-line 1)
	(if (lspool-match-current-lines header-regexp-mmm-2 1)
	    (progn
	      (if (match-beginning 1)
		  (setq article-no (string-to-int
				    (buffer-substring (match-beginning 1) (match-end 1))))
		(setq article-no 0))
	      (forward-line 1))
	  (setq status nil))
	(if (and status (lspool-match-current-lines header-regexp-mmm-3 1))
	    (progn
	      (setq subject (buffer-substring (match-beginning 1) (match-end 1)))
	      (forward-line 1))
	  (setq status nil))
	(if (and status (lspool-match-current-lines header-regexp-mmm-4 1))
	    (progn
	      (setq subject (buffer-substring (match-beginning 1) (match-end 1)))
	      (forward-line 1))
	  )
	(if (and status (lspool-match-current-lines header-regexp-mmm-5 1))
	    (progn
	      (setq date (buffer-substring (match-beginning 1) (match-end 1)))
	      (setq user-id (buffer-substring (match-beginning 2) (match-end 2)))
	      (setq user-name (buffer-substring (match-beginning 3) (match-end 3))))
	  (setq status nil))
	(if (and status (re-search-forward terminal-regexp-mmm-1 nil t))
	    (progn
	      (forward-line 0)
	      (setq j (point))
	      (message "Analyzing ... %s"  board-name)
	      (lspool-add-article-list
	       (concat lspool-host-name "." board-name "." note-no)
	       (vector
		article-no				 ; article
		subject					 ; subject
		(concat user-id "@" lspool-host-name	 ; from
			" (" user-name ")")
		nil					 ; Xref
		(count-lines start j)			 ; lines
		date					 ; date
		(concat "<" (int-to-string article-no) "#" ; message-id
			board-name "." note-no
			"@" lspool-host-name ">")
		nil)
	       start j)
	      (forward-line -1))))))
  (message "done."))

;;;
;;; BigModel
;;;
;;; BigModel $B$N2r@O$OHs>o$K:$Fq!#(B
;;;
;;;$B!V<jF0$G$N%\!<%I$N0\F0!W!V%"%s%1!<%H%\!<%I!W!V(B";aho" $B$N$h$&$JL>A0(B
;;; $B$r$b$?$:(B ";b;1" $B$N$h$&$JL>A0$7$+$b$?$J$$%\!<%I!W!V%+!<%=%k%-!<$HHV(B
;;; $B9f$NF~NO$r;H$C$?%"!<%F%#%/%k$NFI$_9~$_!W$J$I$r40A4$K07$&$?$a$K$O!"(B
;;; $B%[%9%H$N%\!<%I9=@.$d%[%9%H$N8GM-$N%a%C%;!<%8$K4X$9$k>\$7$$%G!<%?$,(B
;;; $BI,MW!#$=$&$$$&LLE]$J$3$H$O$7$J$$!#$=$l$K!"$9$G$K(B BigMode $B$O;~BeCY(B
;;; $B$l$K$J$C$F$$$k!#(B
;;;
;;; $B%l%9%]%s%9%^%M!<%8%c$O$^$@%5%]!<%H$7$F$$$J$$!#(B
;;;

(defvar boardtitle-regexp-bigmodel-1 "^\";\\([^\"]+\\)\"")

(defvar header-regexp-bigmodel-1 "^-[^ ]+- +-[^ ]+- -[^ ]+- -[^ ]+-")
;;(defvar header-regexp-bigmodel-2
;;      "^\\([0-9]+\\)  \\([0-9][0-9][-/][0-9][0-9][-/][0-9][0-9] \
;;[0-9][0-9]:[0-9][0-9]:[0-9][0-9]\\) \\(........\\)  \\(.*\\)$")
(defvar header-regexp-bigmodel-2
      "^\\([0-9]+\\)  \\([0-9][0-9][-/][0-9][0-9][-/][0-9][0-9] \
[0-9][0-9]:[0-9][0-9]:[0-9][0-9]\\) \\(........\\) +\\(.*\\)$")
(defvar header-regexp-bigmodel-3
      "^[0-9]+  [0-9][0-9][-/][0-9][0-9][-/][0-9][0-9] \
[0-9][0-9]:[0-9][0-9]:[0-9][0-9] ........ [^ ]")

(defvar terminal-regexp-bigmodel-1 "^\";\\([^\"]+\\)\"\
\\|^-[^ ]+- +-[^ ]+- -[^ ]+- -[^ ]+-\\|^\\*\\* $B%P%$%J%j%U%!%$%k(B")

(defun lspool-analyze-logfile-bigmodel ()
  (message "Analyzing ...")
  (save-excursion
    (let (article-no user-id user-name board-name date re-article-no
	  line-no subject start j status)
      (set-buffer lspool-analysis-buffer)
      (save-excursion					 ; analyze board title
	(setq lspool-analyze-board-list nil)
	(setq lspool-analyze-current-board nil)
	(while (re-search-forward boardtitle-regexp-bigmodel-1 nil t)
	  (lspool-add-analyze-board-list
	   (point)
	   (buffer-substring (match-beginning 1) (match-end 1)))))

	(setq lspool-analyze-current-board nil)		 ; analyze article
	(while (re-search-forward header-regexp-bigmodel-1 nil t)
	  (setq status t)
	  (forward-line 1)
	  (if (lspool-match-current-lines header-regexp-bigmodel-2 1)
	      (progn
		(while (lspool-match-current-lines header-regexp-bigmodel-2 1)
		  (forward-line 1))
		(forward-line -1)
		(setq start (point))
		(setq article-no (string-to-int
				  (buffer-substring (match-beginning 1) (match-end 1))))
		(setq user-id (buffer-substring (match-beginning 3) (match-end 3)))
		(setq date (buffer-substring (match-beginning 2) (match-end 2)))
		(setq subject (buffer-substring (match-beginning 4) (match-end 4)))
		(setq re-article-no nil)
		(setq board-name (lspool-get-board-from-point (point))))
	    (setq status nil))
	  (if (and status (re-search-forward terminal-regexp-bigmodel-1 nil t))
	      (progn
		(forward-line 0)
		(setq j (point))
		(message "Analyzing ... %s"  board-name)
		(lspool-add-article-list
		 (concat lspool-host-name "." board-name)
		 (vector
		  article-no				 ; article
		  subject				 ; subject
		  (concat user-id "@" lspool-host-name)	 ; from
		  nil					 ; Xref
		  (count-lines start j)			 ; lines
		  date					 ; date
		  (concat "<" (int-to-string article-no) "#" ; message-id
			  board-name "@" lspool-host-name ">")
		  (if re-article-no			 ; references
		      (concat "<" re-article-no "#"
			      board-name "@" lspool-host-name ">")))
		 start j))))))
  (message "done."))

;;;
;;; RTBBS
;;;

(defvar header-regexp-rt-1 "^\\(Read\\|News\\) subjects:\\([ 0-9]+\\)/[ 0-9]+ \
(Remains:[ 0-9]*)")
(defvar header-regexp-rt-2 "^=============================================================")
(defvar header-regexp-rt-3 "^Section : \\(.*\\) (#\\([0-9]+\\)) +No\.\\([ 0-9]+\\)")
(defvar header-regexp-rt-4 "^Sender  : \\([^ ]+\\) +\\[\\(.*\\)\\]")
(defvar header-regexp-rt-5 "^\\(Time\\|Date\\)    : \\([0-9][0-9]/[0-9][0-9]/\
[0-9][0-9] [ 0-9][0-9]:[0-9][0-9]:[0-9][0-9]\\)")
(defvar header-regexp-rt-6 "^Subject : \\(Res \\[#\\([ 0-9]+\\)\\]:\\)?\\(.*\\)$")
(defvar terminal-regexp-rt-1 "^\\(Read\\|News\\) subjects:\\([ 0-9]+\\)/[ 0-9]+ \
(Remains:[ 0-9]*)\
\\|^DIRECTIVE :\\|^BOARD NEWS :")

(defun lspool-analyze-logfile-rt ()
  (message "Analyzing ...")
  (save-excursion
    (let (user-id user-name board-name article-no re-article-no board-title
	  board-no subject date start j status)
      (set-buffer lspool-analysis-buffer)
      (while (re-search-forward  header-regexp-rt-1 nil t)	; analyze article
	(setq status t)
	(setq article-no (string-to-int
			  (buffer-substring (match-beginning 2) (match-end 2))))
        (forward-line 1)
	(if (lspool-match-current-lines header-regexp-rt-2 1)
	    (forward-line 1)
	  (setq status nil))
	(if (and status (lspool-match-current-lines header-regexp-rt-3 1))
	    (progn
	      (forward-line 0)
	      (setq start (point))
	      (setq board-title (buffer-substring (match-beginning 1) (match-end 1)))
	      (setq board-name (buffer-substring (match-beginning 2) (match-end 2)))
	      (forward-line 1))
	  (setq status nil))
	(if (and status (lspool-match-current-lines header-regexp-rt-4 1))
	    (progn
	      (setq user-id (buffer-substring (match-beginning 1) (match-end 1)))
	      (setq user-name (buffer-substring (match-beginning 2) (match-end 2)))
	      (forward-line 1))
	  (setq status nil))
	(if (and status (lspool-match-current-lines header-regexp-rt-5 1))
	    (progn
	      (setq date (buffer-substring (match-beginning 2) (match-end 2)))
	      (forward-line 1))
	  (setq status nil))
	(if (and status (lspool-match-current-lines header-regexp-rt-6 1))
	    (progn
	      (setq re-article-no
		    (if (match-beginning 2)
			(string-to-int
			 (buffer-substring (match-beginning 2) (match-end 2)))
		      nil))
	      (setq subject (buffer-substring (match-beginning 3) (match-end 3))))
	  (setq status nil))
	(if (and status (re-search-forward terminal-regexp-rt-1 nil t))
	    (progn
	      (lspool-add-board-title-list
	       (concat lspool-host-name "." board-name)
	       board-title)
	      (forward-line 0)
	      (setq j (point))
	      (message "Analyzing ... %s"  board-name)
	      (lspool-add-article-list
	       (concat lspool-host-name "." board-name)
	       (vector
		article-no				 ; article
		subject					 ; subject
		(concat user-id "@" lspool-host-name	 ; from
			" (" user-name ")")
		nil					 ; Xref
		(count-lines start j)			 ; lines
		date					 ; date
		(if article-no				 ; message-id
		    (concat "<" (int-to-string article-no) "#"
			    board-name "@" lspool-host-name ">")
		  nil)
		(if re-article-no			 ; references
		    (concat "<" re-article-no "#"
			    board-name "@" lspool-host-name ">")))
	       start j)
	      (forward-line -1))))))
  (message "done."))

;;;
;;; KTBBS
;;;

(defvar header-regexp-kt-1 "^Message  +# *\\([0-9]+\\) is \
from: +\\([^ ]+\\) +\\(.*\\)$")
(defvar header-regexp-kt-2 "^Time: \\([0-9][0-9]/[0-9][0-9]/[0-9][0-9] \
[ 0-9][0-9]:[0-9][0-9]:[0-9][0-9]\\) Section \\([0-9]+\\): \\(.*\\)$")
(defvar header-regexp-kt-3 "Subj: \\(.*\\)$")
(defvar header-regexp-kt-4 "^Re:\\([0-9]+\\))\\(.*\\)$")
(defvar not-header-regexp-kt-1 "^$B$3$l$G$h$m$7$$$G$9$+!)(B (Y/N/Quit)>")
(defvar terminal-regexp-kt-1 "^\\(Message  +# *\\([0-9]+\\) is \
from: +\\([^ ]+\\) +\\(.*\\)\\|$B8!:w=*N;$7$^$7$?(B\\)$")

(defun lspool-analyze-logfile-kt ()
  (message "Analyzing ...")
  (save-excursion
    (let (user-id user-name board-name article-no re-article-no board-title
	  board-no subject date start j status)
      (set-buffer lspool-analysis-buffer)
      (while (re-search-forward  header-regexp-kt-1 nil t)	; analyze article
	(setq status t)
	(forward-line 0)
	(setq start (point))
	(setq article-no (string-to-int
			  (buffer-substring (match-beginning 1) (match-end 1))))
	(setq user-id (buffer-substring (match-beginning 2) (match-end 2)))
	(setq user-name (buffer-substring (match-beginning 3) (match-end 3)))
        (forward-line 1)
	(if (lspool-match-current-lines header-regexp-kt-2 1)
	    (progn 
	      (setq date (buffer-substring (match-beginning 1) (match-end 1)))
	      (setq board-name (buffer-substring (match-beginning 2) (match-end 2)))
	      (setq board-title (buffer-substring (match-beginning 3) (match-end 3)))
	      (forward-line 1))
	  (setq status nil))
	(if (and status
		 (lspool-match-current-lines header-regexp-kt-3 1)
		 (not (lspool-match-current-lines not-header-regexp-kt-1 3)))
	    (progn
	      (setq subject (buffer-substring (match-beginning 1) (match-end 1)))
	      (setq re-article-no nil)
	      (if (string-match header-regexp-kt-4 subject)
		  (progn 
		    (setq re-article-no 
			  (substring subject (match-beginning 1) (match-end 1)))
		    (setq subject (substring subject 
					     (match-beginning 2) (match-end 2))))))
	  (setq status nil))
	(if (and status (re-search-forward terminal-regexp-kt-1 nil t))
	    (progn
	      (lspool-add-board-title-list
	       (concat lspool-host-name "." board-name)
	       board-title)
	      (forward-line 0)
	      (setq j (point))
	      (message "Analyzing ... %s"  board-name)
	      (lspool-add-article-list
	       (concat lspool-host-name "." board-name)
	       (vector
		article-no				 ; article
		subject					 ; subject
		(concat user-id "@" lspool-host-name	 ; from
			" (" user-name ")")
		nil					 ; Xref
		(count-lines start j)			 ; lines
		date					 ; date
		(if article-no				 ; message-id
		    (concat "<" (int-to-string article-no) "#"
			    board-name "@" lspool-host-name ">")
		  nil)
		(if re-article-no			 ; references
		    (concat "<" re-article-no "#"
			    board-name "@" lspool-host-name ">")))
	       start j)
	      (forward-line -1))))))
  (message "done."))

;;;
;;; NNTP Interface.
;;;

(defun lspool-retrieve-headers (sequence)
  (let (headers article)
    (while sequence
      (setq article (gnus-gethash (int-to-string (car sequence))
				  lspool-current-board-article-hashtb))
      (if article
	  (setq headers (cons (car article) headers)))
      (setq sequence (cdr sequence)))
    (nreverse headers)))

(defun lspool-open-server (host &optional service)
  "Read and analyze LOGFILE."
  (save-excursion
    (if (string-match ":\\(.*\\)$" host)
	(progn 
	  (setq lspool-logfile
		(expand-file-name (substring host (match-beginning 1) (match-end 1))
				  (expand-file-name "~/" nil)))
	  (if (file-readable-p lspool-logfile)
	      (progn
		(setq nntp-status-string "")
		(setq nntp-server-name host)
		(setq nntp-server-buffer (get-buffer-create " *nntpd*"))
		(set-buffer nntp-server-buffer)
		(buffer-flush-undo (current-buffer))
		(erase-buffer)
		(kill-all-local-variables)
		(if lspool-article-hashtb-by-id
		    nil
		  (setq lspool-article-hashtb-by-id (gnus-make-hashtable 2027)))
		(if lspool-article-hashtb
		    nil
		  (setq lspool-article-hashtb (gnus-make-hashtable 509)))
		(if lspool-analysis-buffer
		    (set-buffer lspool-analysis-buffer)
		  (setq lspool-analysis-buffer
			(get-buffer-create " *LOG ANALYSIS*"))
		  (set-buffer lspool-analysis-buffer)
		  (buffer-flush-undo (current-buffer))
		  (erase-buffer))
		(goto-char (point-max))
		(insert-file lspool-logfile)
		(if (funcall lspool-select-host-name-function)
		    nil
		  (setq lspool-host-name
			(completing-read "host name: " lspool-hosts-alist
					 nil t nil)))
		(funcall (car (cdr (assoc lspool-host-name
					lspool-hosts-alist)))))
	    (setq nntp-status-string "file not found. Goodbye.")
	    nil)))))

(defun lspool-close-server ()
  (if lspool-analysis-buffer
      (kill-buffer lspool-analysis-buffer))
  (setq lspool-analysis-buffer nil)
  (setq lspool-article-hashtb nil)
  (setq lspool-article-hashtb-by-id nil)
  (setq lspool-board-title-list nil)
  (if nntp-server-buffer
      (kill-buffer nntp-server-buffer))
  (setq nntp-server-buffer nil)
  (setq nntp-server-name nil)
  (setq nntp-server-process nil)
  t)

(defun lspool-server-opened ()
  (and nntp-server-buffer
       (get-buffer nntp-server-buffer)
       lspool-analysis-buffer
       (get-buffer lspool-analysis-buffer)))

(defun lspool-status-message ()
  nntp-status-string)

;;(defun lspool-request-body (id)

;;(defun lspool-request-head (id)

;;(defun lspool-request-head (stat)

(defun lspool-request-article (id)
  (let (article)
    (if (stringp id)
	(setq article (gnus-gethash id lspool-article-hashtb-by-id))
      (setq article (gnus-gethash (int-to-string id)
				  lspool-current-board-article-hashtb)))
    (if article
	(save-excursion
	  (set-buffer lspool-analysis-buffer)
	  (let* ((points (cdr article))
		 (article-vector (car article))
		 (atricle-string
		  (buffer-substring (car points) (car (cdr points)))))
	    (set-buffer nntp-server-buffer)
	    (erase-buffer)
	    (if lspool-insert-news-headers
		(insert
		 (concat "From: " (elt article-vector 2)
			 "\nNewsgroups: " lspool-current-board
			 "\nSubject: " (elt article-vector 1)
			 "\nMessage-ID: " (elt article-vector 6)
			 "\nDate: " (elt article-vector 5)
			 (if (elt article-vector 7)
			     (concat "\nReferences: " (elt article-vector 7))
			   "")
			 "\nLines: " (int-to-string (elt article-vector 4))
			 (if (elt article-vector 3)
			     (concat "\nXref: " (elt article-vector 3))
			   "")
			 "\n\n")))
	    (insert atricle-string)
	    (if lspool-nntp-answer-coding-system
		(code-convert (point-min) (point-max)
			      *internal* lspool-nntp-answer-coding-system))
	    t)))))

(defun lspool-request-group (group)
  (let ((article-hashtb (gnus-gethash group lspool-article-hashtb)))
    (if article-hashtb
	(progn
	  (setq lspool-current-board-article-hashtb article-hashtb)
	  (setq lspool-current-board group)))))

(defun lspool-request-list ()
  (save-excursion
    (let (article-no-list)
      (set-buffer nntp-server-buffer)
      (erase-buffer)
      (mapatoms (function 
		 (lambda (x)
		   (setq article-no-list nil)
		   (mapatoms (function
			      (lambda (y)
				(setq article-no-list
				      (cons (string-to-int (symbol-name y))
					    article-no-list))))
			     (symbol-value x))
		   (insert
		    (concat (symbol-name x) " "
			    (int-to-string (apply 'max article-no-list))
			    " "
			    (int-to-string (apply 'min article-no-list))
			    " y\n"))))
		lspool-article-hashtb)))
  t)

(defun lspool-request-list-newsgroups ()
  "List newsgoups (defined in NNTP2)."
  (setq nntp-status-string "LSPOOL: LIST NEWSGROUPS is not implemented.")
  nil
  )

(defun lspool-request-list-distributions ()
  "List distributions (defined in NNTP2)."
  (setq nntp-status-string "LSPOOL: LIST DISTRIBUTIONS is not implemented.")
  nil
  )

(defun lspool-request-last ()
  (setq nntp-status-string "LSPOOL: LAST is not implemented.")
  nil
  )

(defun lspool-request-next ()
  "Advance current article pointer."
  (setq nntp-status-string "LSPOOL: NEXT is not implemented.")
  nil
  )

(defun lspool-get-upfile-name (hostname)
  " HOSTNAME $B$KBP1~$9$k%"%C%W%m!<%I%U%!%$%kL>$rJV$9!#(B
lspool-hosts-alist $B$N(B 5 $BHVL\$N9`$,(B nil $B$G$J$$$J$i$=$l$r!"(B
nil $B$J$i(B ~/\"HOSTNAME\".up $B$rJV$9!#(B"
  (let ((host (assoc hostname lspool-hosts-alist))
	upfile-name)
    (if host (setq upfile-name (elt host 4)))
    (if upfile-name
	nil
      (setq upfile-name (concat hostname ".up")))
    (expand-file-name upfile-name "~/")))

(defun lspool-request-post ()
  "Post a new news in current buffer."
  (let (newsgroup subject references host-name boardname hstart astart i)
    (setq hstart (point-min))
    (goto-char (point-min))
    (re-search-forward "\n\n")
    (setq astart (point))
    (setq newsgroup (lspool-get-string-from-header "^Newsgroups: " hstart astart))
    (setq i (string-match "\\." newsgroup))
    (setq host-name (substring newsgroup 0 i))
    (if (member host-name internet-top-newsgoups)
	(setq host-name "internet"))
    (setq boardname (substring newsgroup (1+ i)))
    (setq subject (lspool-get-string-from-header "^Subject: " hstart astart))
    (setq references (lspool-get-string-from-header "^References: " hstart astart))
    (funcall (elt (assoc host-name lspool-hosts-alist) 2)
	     host-name boardname subject references astart (point-max))))

;;;
;;; mail and post
;;;

(defun lspool-post-netcock
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 50 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert "\\" boardname "\n")
      (if references
	  (progn
	    (string-match "<\\([0-9]+\\)[^<>]*>\\'" references)
	    (insert (substring references (match-beginning 1) (match-end 1))
		    "\nP" subject "\n"))
	(insert "W" subject "\n"))
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert ".\nYQ\n")
	(insert "\n.\nYQ\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-mail-netcock
  (host-name userid subject reply article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 50 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert "MW\n" userid "\nY\n" subject "\n")
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert ".\nY\n")
	(insert "\n.\nY\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))


(defun lspool-post-nifty
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 40 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (if (not (string-match "\\([a-z0-9]+\\)\\.\\([a-z0-9]+\\)" boardname))
	  (yes-or-no-p "$B$"$l$'!)(B "))
      (insert "go " (substring boardname (match-beginning 1) (match-end 1)) "\n")
      (insert "mes " (substring boardname (match-beginning 2) (match-end 2)) "\n")
      (if references
	  (progn
	    (string-match "<\\([0-9]+\\)[^<>]*>\\'" references)
	    (insert "re " (substring references (match-beginning 1) (match-end 1))
		    "\nSUB:" subject "\n"))
	(insert "com\nSUB:" subject "\n"))
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert "/post\n")
	(insert "\n/post\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-mail-nifty
  (host-name userid subject reply article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 40 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert "go mail\ncom\nTO:" userid "\nSUB:" subject "\n")
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert "/post\n")
	(insert "\n/post\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-post-muhost
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 34 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (if (string-match "\\(.*\\)\\.\\([0-9]+\\)$" boardname)
	  (insert (substring boardname (match-beginning 1) (match-end 1))
		  "\ni "
		  (substring boardname (match-beginning 2) (match-end 2))
		  "\n")
	(insert boardname "\n"))
      (if references
	  (progn
	    (string-match "<\\([0-9]+\\)[^<>]*>\\'" references)
	    (insert "a " (substring references (match-beginning 1) (match-end 1))
		    "\n" subject "\n"))
	(insert "w\n" subject "\n"))
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert ".\n1\n")
	(insert "\n.\n1\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-mail-muhost
  (host-name userid subject reply article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 34 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert "mail\nw\nsun" userid "\ny\n" subject "\n")
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert ".\n1\n")
	(insert "\n.\n1\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-post-maple
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer
	   keyword)
      (setq keyword (lspool-get-string-from-header "^Keyword: " (point-min) nil))
      (if keyword
	  nil
	(setq keyword ""))
      (if (< 9 (length (code-convert-string keyword *internal* *sjis*)))
	  (error "keyword too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (if references
	  (progn
	    (string-match "<\\([0-9]+\\)[^<>]*>\\'" references)
	    (insert "bbs follow #" boardname " a"
		    (substring references (match-beginning 1) (match-end 1))
		    (if (string= keyword "") "" " keyword=")
		    keyword "\n"))
	(insert "bbs post #" boardname "\n" subject "\n" keyword "\n"))
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert ".\n")
	(insert "\n.\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-mail-maple
  (host-name userid subject reply article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert "mail post MAP" userid "\n")
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert ".\n")
	(insert "\n.\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-post-rmail-netnews
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (boundp 'MULE)
	  (setq upload-buffer (find-file-noselect upload-filename *junet*unix))
	(setq upload-buffer (find-file-noselect upload-filename *junet*unix)))
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (set-buffer cbuffer)
      (goto-char (point-max))
      (if (not (bolp))
	  (insert "\n"))
      (goto-char (point-min))
      (insert "POST\r\n")
      (narrow-to-region (point-min) (search-forward "\n\n" nil))
      (goto-char (point-min))
      (delete-matching-lines "^Message-ID:")
      (widen)
      (while (search-forward "\n." nil t)
	(insert "."))
      (goto-char (point-max))
      (insert ".\r\n")
      (append-to-buffer upload-buffer (point-min) (point-max))
      (set-buffer upload-buffer)
      (if (boundp 'MULE) (set-file-coding-system *junet*unix))
      (save-buffer)
      t)))

(defun lspool-post-bigmodel
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 21 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert ";" boardname "\n")
      (insert "w\n" subject "\n")
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert "^\nY\n")
	(insert "\n^\nY\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-mail-bigmodel
  (host-name userid subject reply article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 21 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert ";M\nW\n" userid "\nY\nN\n" subject "\n")
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert "^\nY\n")
	(insert "\n^\nY\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-post-rt
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert "B#" boardname "\n")
      (if references
	  (progn
	    (string-match "<\\([0-9]+\\)[^<>]*>\\'" references)
	    (insert  "R\n" (substring references (match-beginning 1) (match-end 1))
		    "\n" subject "\ny\n"))
	(insert "e\n" subject "\ny\n"))
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert "//\nw\n0\n0\n0\n0\n")
	(insert "\n//\nw\n0\n0\n0\n0\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-post-kt
  (host-name boardname subject references article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 50 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (if references
	  (progn
	    (string-match "<\\([0-9]+\\)[^<>]*>\\'" references)
	    (insert "er;" boardname ";" (substring references (match-beginning 1) (match-end 1)) "\ny\n"))
	(insert "ew;" boardname ";" subject ";y\n"))
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert "//\ns\n")
	(insert "\n//\ns\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))

(defun lspool-mail-kt
  (host-name userid subject reply article-beginning article-end)
  (save-excursion
    (let* ((cbuffer (current-buffer))
	   (upload-filename (lspool-get-upfile-name host-name))
	   upload-buffer)
      (if (< 21 (length (code-convert-string subject *internal* *sjis*)))
	  (error "subject too long."))
      (if (boundp 'MULE)
	  (set-buffer (find-file-noselect upload-filename *sjis*dos))
	(set-buffer (find-file-noselect upload-filename)))
      (setq upload-buffer (current-buffer))
      (goto-char (point-max))
      (insert "em\n" userid "\n\n" subject "\ny\n")
      (set-buffer cbuffer)
      (append-to-buffer upload-buffer article-beginning article-end)
      (set-buffer upload-buffer)
      (goto-char (point-max))
      (if (eq (char-after (1- (point))) 10)
	  (insert "//\ns\n")
	(insert "\n//\ns\n"))
      (if (boundp 'MULE) (set-file-coding-system *sjis*dos))
      (save-buffer)
      t)))
;;;
;;; sendmail interface
;;;

(defun lspool-sendmail-send-it ()
  (let (to host-name userid reply subject host i)
    (goto-char (point-min))
    (re-search-forward "^To: ")
    (setq i (point))
    (forward-line 1)
    (setq to (buffer-substring i (1- (point))))
    (string-match "\\(.+\\)@\\([^ @]+\\)\\($\\| .*\\)" to)
    (setq userid (substring to (match-beginning 1) (match-end 1)))
    (setq host-name (substring to (match-beginning 2) (match-end 2)))
    (goto-char (point-min))
    (if (re-search-forward "In reply to: " nil t)
	(progn
	  (setq i (point))
	  (forward-line 1)
	  (setq reply (buffer-substring i (1- (point))))))
    (goto-char (point-min))
    (re-search-forward "^Subject: ")
    (setq i (point))
    (forward-line 1)
    (setq subject (buffer-substring i (1- (point))))
    (re-search-forward "--text follows this line--\n")
    (setq i (point))
    (setq host (assoc host-name lspool-hosts-alist))
    (if host
	(funcall (elt host 3)
		 host-name userid subject reply i (point-max))
      (lspool:org:sendmail-send-it))))

(if (fboundp 'lspool:org:sendmail-send-it)
    nil
  (fset 'lspool:org:sendmail-send-it 'sendmail-send-it)
  (fset 'sendmail-send-it 'lspool-sendmail-send-it))

;;
;;
;;

(defun lspool-select-host-name-from-logfile-contents ()
    (let ((host-list lspool-hosts-alist)
	  result host host-select-list)
      (while host-list
	(save-excursion
	  (setq host (car host-list))
	  (setq host-select-list (elt host 5))
	  (setq host-list (cdr host-list))
	  (if (and host-select-list
		   (if (elt host-select-list 2)
		       (re-search-forward (car (cdr host-select-list))
					  (+ (car host-select-list) (point)) t)
		     (search-forward (car (cdr host-select-list))
				     (+ (car host-select-list) (point)) t)))
	      (progn
		(setq lspool-host-name (car host))
		(setq result t)
		(setq host-list nil)))))
      result))

(defun lspool-group-get-new-news (&optional n)
  (interactive "P")
  (let (directory files)
    (if n
	(progn
	  (while (progn
		   (setq directory 
			 (read-file-name "logfile directory: "
					 (file-name-directory lspool-logfile)
					 (file-name-directory lspool-logfile)
					 t))
		   (not (file-directory-p directory))))
	  (setq files (directory-files
		       directory t
		       (read-string "file name regexp: "
				    (file-name-nondirectory lspool-logfile))))
	  (if files
	      nil
	    (error "No file match.")))
      (setq files (list (read-file-name "new log filename: " lspool-logfile "" t))))
    (while files
      (if (string= (car files) "")
	  nil
	(setq gnus-nntp-server (concat ":" (expand-file-name (car files))))
	(lspool-open-server gnus-nntp-server)
	(setq files (cdr files))))
;;      (gnus-setup-news)
    (gnus-setup-news t)
    (gnus-group-list-groups gnus-have-all-newsgroups)))

(defun lspool-delete-newsgroup (group)
  "Kill GROUP from gnus-newsrc-assoc, .newsrc and gnus-unread-hashtb."
  (let ((info (gnus-gethash group gnus-newsrc-hashtb)))
    (if (null info)
	nil
      (setq gnus-newsrc-assoc (delq info gnus-newsrc-assoc))
      (gnus-sethash group nil gnus-newsrc-hashtb)
      (gnus-sethash group nil gnus-unread-hashtb)
      (gnus-update-newsrc-buffer group 'delete)
      info
      )))

(defun lspool-delete-newsgroups ()
  (let (delete-hashtbl)
    (mapatoms
     (function 
      (lambda (newsgroup)
	(if (string-match lspool-delete-newsgroup-regexp
			  (symbol-name newsgroup))
	    (gnus-sethash (symbol-name newsgroup) nil  delete-hashtbl))))
     gnus-newsrc-hashtb)
    (mapatoms (function
	       (lambda (newsgroup) 
		 (lspool-delete-newsgroup (symbol-name newsgroup))))
	      delete-hashtbl)))

(defun gnus-lspool (file)
  (interactive "flog filename: ")
  (setq gnus-thread-ignore-subject t)
  (setq gnus-thread-hide-subject nil)
  (setq lspool-insert-news-headers t)
  (setq gnus-optional-headers 'gnus-optional-from)
  (if lspool-ignored-headers
      (setq gnus-ignored-headers lspool-ignored-headers))
  (lspool-close-server)
  (setq gnus-nntp-server
	(concat ":" (expand-file-name file)))
  (gnus))

;;; Local Variables: ***
;;; comment-column:57 ***
;;; comment-start: "; " ***
;;; backup-inhibited: nil ***
;;; End: ***

; (defun gnus-group-update-group (group &optional visible-only)
;   "Update newsgroup info of GROUP.
; If optional argument VISIBLE-ONLY is non-nil, non displayed group is ignored."
;   (let ((buffer-read-only nil)
; 	(case-fold-search nil)		;appleIIgs vs. appleiigs
; 	(regexp (gnus-group-make-regexp group))
; 	(visible nil))
;     ;; Buffer may be narrowed.
;     (save-restriction
;       (widen)
;       ;; Search a line to modify.  If the buffer is large, the search
;       ;; takes long time.  In most cases, current point is on the line
;       ;; we are looking for.  So, first of all, check current line. 
;       ;; And then if current point is in the first half, search from
;       ;; the beginning.  Otherwise, search from the end.
;       (if (cond ((progn
; 		   (beginning-of-line)
; 		   (looking-at regexp)))
; 		((and (> (/ (buffer-size) 2) (point)) ;In the first half.
; 		      (progn
; 			(goto-char (point-min))
; 			(re-search-forward regexp nil t))))
; 		((progn
; 		   (goto-char (point-max))
; 		   (re-search-backward regexp nil t))))
; 	  ;; GROUP is listed in current buffer. So, delete old line.
; 	  (progn
; 	    (setq visible t)
; 	    (beginning-of-line)
; 	    (delete-region (point) (progn (forward-line 1) (point)))
; 	    )
; 	;; No such line in the buffer, so insert it at the top.
; 	(goto-char (point-min)))
;       (if (or visible (not visible-only))
; 	  (progn
; 	    (insert (gnus-group-prepare-line
; 		     (gnus-gethash group gnus-newsrc-hashtb)))
; 	    (forward-line -1)		;Move point on that line.
; 	    (run-hooks 'gnus-group-update-group-hook)
; 	    ))
;       )))
